{   Problema se rezolva prin programare dinamica.
   Ceea ce o face interesanta  nu este conditia de sortare crescatoare
 a inaltimilor ci faptul ca fiecare persoana are un moment de plecare de
 la fotograf, deci nu este prezenta in orice moment.
   De aceea am considerat pe rand momentele 1, 2, ..., n, in momentele n+1,
 n+2 s.a.m.d. nefiind realizabila vreo fotografie care sa nu poate fi
 realizata intr-unul din momentele anterioare.
   Extrag persoanele prezente la momentul t si determin cate poze de k
 persoane pot fi realizate astfel incat ultima persoana din fotografie
 sa fie persoana care a aparut la fotograf la momentul t. Suma acestor
 valori este evident numarul de poze distincte care pot fi realizate.
   Construiesc o matrice (alocata dinamic datorita faptului ca are
 componente apartinand tipului real) in care v[i]^[j] retine cate
 fotografii de lungime i se pot face astfel incat ultima persoana din
 fotografie sa fie persoana j. Relatiile de recurenta sunt simple : v[i]^[j]
 se incrementeaza cu toti v[i-1]^[k] cu conditia ca persoana k sa fie cel
 mult la fel de inalta ca persoana j. Voi obtine in v[k]^[t] numarul de poze
 de lungime k in care ultima persoana este cea sosita la momentul t.
 O variabila globala sum va fi incrementata cu valorea v[k]^[t]. Dupa ce
 t baleiaza intervalul [k..n] in sum voi avea numarul total de poze distincte
 de lungime k ce pot fi realizate.
   Determinarea persoanei (persoanelor) ce participa la un numar maxim de
 fotografii este putin mai dificila. Pentru aceasta retin o lista a
 persoanelor care se pot afla pe pozitia p a fotografiei, cu p luand valori
 de la k la 1. Lista este initializata cu persoana aflata pe ultima pozitie
 din poza, adica persoana sosita la momentul t. Apoi, tinand seama de
 conditia ca persoanele sa fie asezate in ordine crescatoare, se determina
 lista persoanelor care se pot afla pe pozitia k-1, apoi pe pozitia k-2, ...
 pana la pozitia 1. Se calculeaza astfel un vector numit de mine part, in
 care part[i] arata de cate ori participa persoana i la o poza de lungime k.
 La sfarsit se alege maximul vectorului.
   Complexitatea algoritmului este destul de mare, ea putand sa atinga pe
 cazuri defavorabile (ordinea sosirii coincide cu ordinea inaltimilor iar
 orice persoana sta la fotograf oricat timp) O(N^3*K).
   Inca ceva : am gasit si eu aceasta problema printre multe altele pe
 calculatorul meu, impreuna cu o sursa (pe care o banuiesc a fi a
 dumneavoastra, sau, daca nu, atunci probabil cea mai buna sursa din
 concurs) precum si cele 5 teste date. Sursa mea se comporta mai bine decat
 cea "oficiala" d.p.d.v. al timpului de rulare (chiar daca a mea calculeaza
 in real iar cealalta in longint) insa rezultatele din pacate difera. Numarul
 maxim de poze distincte este gasit la fel, insa persoana care participa la
 un numar maxim de poze precum si acest numar maxim difera. Nu cred ca am
 gresit eu, mai ales ca am gasit un test mic, care poate fi verificat de
 mana si pe care sursa mea il trece, cea "oficiala" nu. Acest test este :
  7 3      // sunt 7 persoane; se fac poze de cate 3 persoane;
  1 3      // prima persoana are inaltimea 1 si sta 3 momente;
  2 3      // a doua persoana are inaltimea 2 si sta 3 momente;
  3 5
  4 2
  5 1      ...................................................
  6 2
  7 1      // a saptea persoana are inaltimea 7 si sta 1 moment;

  Pe acest test se pot face 11 poze distincte:
  1 2 3
  1 2 4
  1 3 4
  2 3 4
  2 3 5
  2 4 5
  3 4 5
  3 4 6
  3 5 6
  4 5 6
  3 6 7
  Se vede clar ca persoana 3 participa la un numar maxim de poze, adica 8.
  Sursa "oficiala" determina bine numarul maxim de poze distincte (11),
 determina bine si persoana care face parte dintr-un numar maxim de poze (3)
 dar "se buseste" la determinarea acestui maxim (8).
  Cam atat despre aceasta problema. Din nou, as fi interesat (dace se poate)
 de solutia lui Angel precum si de solutia prezentata de dumneavoastra la
 propunerea problemei.
}


program poza;

const ni='poza.in';
      no='';
      nmax=100;

type sir=array [1..nmax] of real;
     psir=^sir;
     mat=array [1..nmax] of psir;

var v:mat;
    f:text;
    who,h,sta,a:array [1..nmax] of longint;
    pers,i,j,n,k,p,r,t:longint;
    s,ss,part:sir;
    max,sum:real;

procedure load;
begin
     assign(f,ni);reset(f);
     readln(f,n,k);
     for i:=1 to n do
        readln(f,h[i],sta[i]);
     close(f);
     for i:=1 to k do
        new(v[i]);
end;

procedure work;
begin
     for i:=k to n do begin
        p:=0;
        for j:=1 to i do
           if j+sta[j]>=i then begin
             p:=p+1;
             a[p]:=h[j];
             who[p]:=j;
                                 end;
        if p>=k then begin
          for j:=1 to k do
             for r:=1 to p do
                v[j]^[r]:=0;
          v[1]^[1]:=1;
          for j:=2 to p do begin
             v[1]^[j]:=1;
             for r:=1 to j-1 do
                if a[r]<=a[j] then
                  for t:=1 to k-1 do
                     v[t+1]^[j]:=v[t+1]^[j]+v[t]^[r];
                           end;
          sum:=sum+v[k]^[p];
          for j:=1 to p do
             s[j]:=0;
          s[p]:=1;
          for j:=k downto 1 do begin
             for t:=1 to p do
                part[who[t]]:=part[who[t]]+s[t]*v[j]^[t];
             for t:=1 to p do
                ss[t]:=0;
             for t:=1 to p do
                for r:=1 to t-1 do
                   if a[r]<=a[t] then
                     ss[r]:=ss[r]+s[t];
             s:=ss;
                              end;
                     end;
                      end;
     max:=0;
     for i:=1 to n do
        if part[i]>max then max:=part[i];
end;

procedure scrie;
begin
     assign(f,no);rewrite(f);
     writeln(f,'Numarul maxim de poze distincte : ',sum:0:0);
     if sum>0 then begin
       write(f,'Persoanele cu numerele de ordine : ');
       for i:=1 to n do
          if part[i]=max then write(f,i,' ');
       writeln(f,'participa la ',max:0:0,' poze.');
                   end;
     close(f);
end;

begin {programul principal}
     load;
     work;
     scrie;
end.

